/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu;

import ru.ispras.microtesk.model.api.ProcessorModel;
import ru.ispras.microtesk.model.api.metadata.MetaModelPrinter;
import ru.ispras.microtesk.model.api.state.ModelStatePrinter;
import ru.ispras.microtesk.model.api.instruction.AddressingMode;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.cpu.metadata.MetaModel;
import ru.ispras.microtesk.model.cpu.mode.*;
import ru.ispras.microtesk.model.cpu.op.*;

import static ru.ispras.microtesk.model.cpu.Shared.*;

public final class Model extends ProcessorModel {
  public static final String NAME = "cpu";

  private static final AddressingMode.IInfo[] __MODES = new AddressingMode.IInfo[] {
    IMM.INFO,
    REG.INFO,
    MEM.INFO
  };

  private static final Operation.IInfo[] __OPS = new Operation.IInfo[] {
    ADD.INFO,
    SUB.INFO,
    MOV.INFO,
    alu_instr.INFO,
    J.INFO,
    JZ.INFO
  };

  public Model() {
    super(
        NAME,
        new MetaModel(),
        __MODES,
        __OPS,
        __REGISTERS,
        __MEMORY,
        __VARIABLES,
        __LABELS
        );
  }

  public static void printInformation() {
    final Model model = new Model();

    final MetaModelPrinter metaModelPrinter = new MetaModelPrinter(model.getMetaData());
    metaModelPrinter.printAll();

    final ModelStatePrinter modelStatePrinter = new ModelStatePrinter(model);
    modelStatePrinter.printRegisters();
  }

  public static void main(String[] args) {
    printInformation();
  }
} 