/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;

import static ru.ispras.microtesk.model.minimips.Shared.*;

public final class instruction extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         instruction.class,
         "instruction",
         new ArgumentDecls()
             .add("command", Operations.INFO));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Operation command = (Operation) getArgument("command", args);

      return new instruction(command);
    }
  }
  public static final IInfo INFO = new Info();

  public final Operation command;

  public instruction(final Operation command) {
    assert Operations.INFO.isSupported(command);
    this.command = command;
  }

  @Override
  public String syntax() {
    return command.syntax();
  }

  @Override
  public String image() {
    return command.image();
  }

  @Override
  public void action() {
    GPR.access(0).store(Data.valueOf(WORD, 0x0));
    is_delay_slot.access().store(BRANCH.access().load());
    jump_address.access().store(JMPADDR.access().load());
    BRANCH.access().store(Data.valueOf(BIT, 0x0));
    JMPADDR.access().store(Data.valueOf(WORD, 0x0));
    command.execute();
    if (is_delay_slot.access().load().equals(Data.valueOf(BIT, 0x1)) && BRANCH.access().load().equals(Data.valueOf(BIT, 0x1))) {
      Execution.unpredicted();
    }
    if (is_delay_slot.access().load().equals(Data.valueOf(BIT, 0x1))) {
      CIA.access().store(jump_address.access().load());
    } else {
      CIA.access().store(CIA.access().load().add(Data.valueOf(WORD, 0x4)));
    }
  }
}