/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.mode;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.x86.Shared.*;

public final class BIAM_BX_SI extends AddressingMode {
  public static final String NAME = "BIAM_BX_SI";

  private static final class Info extends InfoAndRule {
    Info() {
      super(
          BIAM_BX_SI.class,
          "BIAM_BX_SI",
          ADDR,
          new ArgumentDecls()
      );
    }

    @Override
    public AddressingMode create(final Map<String, Primitive> args) {
      return new BIAM_BX_SI();
    }
  }

  public static final IInfo INFO = new Info();

  public BIAM_BX_SI() {
  }

  @Override
  public String syntax() {
    init();
    return "[BX+SI]";
  }

  @Override
  public String image() {
    init();
    return "";
  }

  public void init() {
    mod.access().store(Data.valueOf(Type.CARD(2), 0x0));
    rm.access().store(Data.valueOf(Type.CARD(3), 0x0));
  }

  @Override
  public void action() {
    init();
  }

  @Override
  public Location access() {
    return new Location(Data.signExtend(ADDR, Data.cast(SWORD, BX.access().load().add(SI.access().load())))).setName(syntax());
  }
}