/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.mode;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.x86.Shared.*;

public final class IAM_DI_D8 extends AddressingMode {
  public static final String NAME = "IAM_DI_D8";

  private static final class Info extends InfoAndRule {
    Info() {
      super(
          IAM_DI_D8.class,
          "IAM_DI_D8",
          ADDR,
          new ArgumentDecls()
              .add("disp", SBYTE)
      );
    }

    @Override
    public AddressingMode create(final Map<String, Primitive> args) {
      final Immediate disp = (Immediate) getArgument("disp", args);
      return new IAM_DI_D8(disp);
    }
  }

  public static final IInfo INFO = new Info();

  public final Immediate disp;

  public IAM_DI_D8(final Immediate disp) {
    this.disp = disp;
  }

  @Override
  public String syntax() {
    init();
    return String.format("%d[DI]", disp.access().load().bigIntegerValue());
  }

  @Override
  public String image() {
    init();
    return String.format("%s", disp.access().load().toString());
  }

  public void init() {
    mod.access().store(Data.valueOf(Type.CARD(2), 0x1));
    rm.access().store(Data.valueOf(Type.CARD(3), 0x5));
  }

  @Override
  public void action() {
    init();
    instr_size.access().store(instr_size.access().load().add(Data.valueOf(SIZE, 0x1)));
  }

  @Override
  public Location access() {
    return new Location(Data.signExtend(ADDR, Data.cast(SWORD, Data.signExtend(WORD, disp.access().load()).add(DI.access().load())))).setName(syntax());
  }
}