/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.Shared.*;

public final class ADD_R8M8 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         ADD_R8M8.class,
         "ADD_R8M8",
         new ArgumentDecls()
             .add("seg_ovrd", RSEG16.INFO)
             .add("op1", R8.INFO)
             .add("op2", MOFFS.INFO),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final R8 op1 = (R8) getArgument("op1", args);
      final AddressingMode op2 = (AddressingMode) getArgument("op2", args);

      return new ADD_R8M8(seg_ovrd, op1, op2);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "ADD_R8M8",
          new ArgumentDecls()
              .add("seg_ovrd", RSEG16.INFO)
              .add("op1", R8.INFO)
              .add("op2", MOFFS.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final R8 op1 = (R8) getArgument("op1", args);
      final AddressingMode op2 = (AddressingMode) getArgument("op2", args);

      return new x86(
        new ADD_R8M8(
          seg_ovrd,
          op1,
          op2
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final RSEG16 seg_ovrd;
  public final R8 op1;
  public final AddressingMode op2;

  public ADD_R8M8(final RSEG16 seg_ovrd, final R8 op1, final AddressingMode op2) {
    assert RSEG16.INFO.isSupported(seg_ovrd);
    assert R8.INFO.isSupported(op1);
    assert MOFFS.INFO.isSupported(op2);
    this.seg_ovrd = seg_ovrd;
    this.op1 = op1;
    this.op2 = op2;
  }

  @Override
  public String syntax() {
    return String.format("ADD %s, %s:%s", op1.syntax(), seg_ovrd.syntax(), op2.syntax());
  }

  @Override
  public String image() {
    return String.format("001%s11000000010%s%s%s%s", seg_ovrd.image(), mod.access().load().toString(), op1.image(), rm.access().load().toString(), op2.image());
  }

  @Override
  public void action() {
    base.access().store(Data.zeroExtend(ADDR, seg_ovrd.access().load()).shiftLeft(Data.valueOf(ADDR, 0x4)));
    new add_proc_byte(new Immediate(op1.access().load().add(Data.valueOf(Type.CARD(8), 0x0))), new Immediate(M.access(base.access().load().add(op2.access().load())))).execute();
    op1.access().store(tmpb_res.access().bitField(0, 7).load());
    op2.execute();
    instr_size.access().store(instr_size.access().load().add(Data.valueOf(SIZE, 0x3)));
  }
}