/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.Shared.*;

public final class IDIV_M16 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         IDIV_M16.class,
         "IDIV_M16",
         new ArgumentDecls()
             .add("seg_ovrd", RSEG16.INFO)
             .add("op1", MOFFS.INFO),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final AddressingMode op1 = (AddressingMode) getArgument("op1", args);

      return new IDIV_M16(seg_ovrd, op1);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "IDIV_M16",
          new ArgumentDecls()
              .add("seg_ovrd", RSEG16.INFO)
              .add("op1", MOFFS.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final AddressingMode op1 = (AddressingMode) getArgument("op1", args);

      return new x86(
        new IDIV_M16(
          seg_ovrd,
          op1
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final RSEG16 seg_ovrd;
  public final AddressingMode op1;

  public IDIV_M16(final RSEG16 seg_ovrd, final AddressingMode op1) {
    assert RSEG16.INFO.isSupported(seg_ovrd);
    assert MOFFS.INFO.isSupported(op1);
    this.seg_ovrd = seg_ovrd;
    this.op1 = op1;
  }

  @Override
  public String syntax() {
    return String.format("IDIV %s:%s", seg_ovrd.syntax(), op1.syntax());
  }

  @Override
  public String image() {
    return String.format("001%s11011110111%s000%s%s", seg_ovrd.image(), mod.access().load().toString(), rm.access().load().toString(), op1.image());
  }

  @Override
  public void action() {
    base.access().store(Data.zeroExtend(ADDR, seg_ovrd.access().load()).shiftLeft(Data.valueOf(ADDR, 0x4)));
    tmpdw_op1.access().bitField(0, 15).store(AX.access().load());
    tmpdw_op1.access().bitField(16, 31).store(DX.access().load());
    tmpw_op1.access().bitField(0, 7).store(M.access(base.access().load().add(op1.access().load())).load());
    tmpw_op1.access().bitField(8, 15).store(M.access(base.access().load().add(op1.access().load()).add(Data.valueOf(ADDR, 0x1))).load());
    tmpdw_op2.access().store(tmpdw_op1.access().load().divide(Data.signExtend(DWORD, Data.cast(SWORD, tmpw_op1.access().load()))));
    instr_size.access().store(instr_size.access().load().add(Data.valueOf(SIZE, 0x3)));
    op1.execute();
    if (!(((tmpdw_op2.access().load().compareTo(Data.valueOf(DWORD, 0x7fff)) > 0) || (tmpdw_op2.access().load().compareTo(Data.valueOf(DWORD, 0x8000)) < 0)))) {
      AX.access().store(Data.coerce(WORD, tmpdw_op2.access().load()));
      DX.access().store(Data.coerce(WORD, tmpdw_op1.access().load().mod(Data.signExtend(DWORD, Data.cast(SWORD, tmpw_op1.access().load())))));
    }
  }
}