/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.Shared.*;

public final class MOV_R16M16 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         MOV_R16M16.class,
         "MOV_R16M16",
         new ArgumentDecls()
             .add("seg_ovrd", RSEG16.INFO)
             .add("dst", GPR16.INFO)
             .add("src", MOFFS.INFO),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final GPR16 dst = (GPR16) getArgument("dst", args);
      final AddressingMode src = (AddressingMode) getArgument("src", args);

      return new MOV_R16M16(seg_ovrd, dst, src);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "MOV_R16M16",
          new ArgumentDecls()
              .add("seg_ovrd", RSEG16.INFO)
              .add("dst", GPR16.INFO)
              .add("src", MOFFS.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final GPR16 dst = (GPR16) getArgument("dst", args);
      final AddressingMode src = (AddressingMode) getArgument("src", args);

      return new x86(
        new MOV_R16M16(
          seg_ovrd,
          dst,
          src
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final RSEG16 seg_ovrd;
  public final GPR16 dst;
  public final AddressingMode src;

  public MOV_R16M16(final RSEG16 seg_ovrd, final GPR16 dst, final AddressingMode src) {
    assert RSEG16.INFO.isSupported(seg_ovrd);
    assert GPR16.INFO.isSupported(dst);
    assert MOFFS.INFO.isSupported(src);
    this.seg_ovrd = seg_ovrd;
    this.dst = dst;
    this.src = src;
  }

  @Override
  public String syntax() {
    return String.format("MOV %s, %s:%s", dst.syntax(), seg_ovrd.syntax(), src.syntax());
  }

  @Override
  public String image() {
    return String.format("001%s11010001011%s%s%s%s", seg_ovrd.image(), mod.access().load().toString(), dst.image(), rm.access().load().toString(), src.image());
  }

  @Override
  public void action() {
    base.access().store(Data.zeroExtend(ADDR, seg_ovrd.access().load()).shiftLeft(Data.valueOf(ADDR, 0x4)));
    Location.concat(dst.access().bitField(8, 15), dst.access().bitField(0, 7)).store(Location.concat(M.access(base.access().load().add(src.access().load()).add(Data.valueOf(ADDR, 0x1))), M.access(base.access().load().add(src.access().load()))).load());
    src.execute();
    instr_size.access().store(instr_size.access().load().add(Data.valueOf(SIZE, 0x3)));
  }
}