/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.Shared.*;

public final class POP_M16 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         POP_M16.class,
         "POP_M16",
         new ArgumentDecls()
             .add("seg_ovrd", RSEG16.INFO)
             .add("dst", MOFFS.INFO),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final AddressingMode dst = (AddressingMode) getArgument("dst", args);

      return new POP_M16(seg_ovrd, dst);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "POP_M16",
          new ArgumentDecls()
              .add("seg_ovrd", RSEG16.INFO)
              .add("dst", MOFFS.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final AddressingMode dst = (AddressingMode) getArgument("dst", args);

      return new x86(
        new POP_M16(
          seg_ovrd,
          dst
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final RSEG16 seg_ovrd;
  public final AddressingMode dst;

  public POP_M16(final RSEG16 seg_ovrd, final AddressingMode dst) {
    assert RSEG16.INFO.isSupported(seg_ovrd);
    assert MOFFS.INFO.isSupported(dst);
    this.seg_ovrd = seg_ovrd;
    this.dst = dst;
  }

  @Override
  public String syntax() {
    return String.format("POP %s:%s", seg_ovrd.syntax(), dst.syntax());
  }

  @Override
  public String image() {
    return String.format("001%s11010001111%s000%s%s", seg_ovrd.image(), mod.access().load().toString(), rm.access().load().toString(), dst.image());
  }

  @Override
  public void action() {
    base.access().store(Data.zeroExtend(ADDR, seg_ovrd.access().load()).shiftLeft(Data.valueOf(ADDR, 0x4)));
    M.access(base.access().load().add(dst.access().load())).store(M.access(Data.zeroExtend(ADDR, SS.access().load()).shiftLeft(Data.valueOf(ADDR, 0x4)).add(Data.signExtend(ADDR, Data.cast(SWORD, SP.access().load())))).load());
    M.access(base.access().load().add(dst.access().load()).add(Data.valueOf(ADDR, 0x1))).store(M.access(Data.zeroExtend(ADDR, SS.access().load()).shiftLeft(Data.valueOf(ADDR, 0x4)).add(Data.signExtend(ADDR, Data.cast(SWORD, SP.access().load().add(Data.valueOf(WORD, 0x1)))))).load());
    SP.access().store(SP.access().load().add(Data.valueOf(WORD, 0x2)));
    dst.execute();
    instr_size.access().store(instr_size.access().load().add(Data.valueOf(SIZE, 0x3)));
  }
}