/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.Shared.*;

public final class POP_RSEG extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         POP_RSEG.class,
         "POP_RSEG",
         new ArgumentDecls()
             .add("dst", RSEG16.INFO),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 dst = (RSEG16) getArgument("dst", args);

      return new POP_RSEG(dst);
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "POP_RSEG",
          new ArgumentDecls()
              .add("dst", RSEG16.INFO)
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final RSEG16 dst = (RSEG16) getArgument("dst", args);

      return new x86(
        new POP_RSEG(
          dst
        )
      );
    }
  }
  public static final IInfo INFO = new Info();

  public final RSEG16 dst;

  public POP_RSEG(final RSEG16 dst) {
    assert RSEG16.INFO.isSupported(dst);
    this.dst = dst;
  }

  @Override
  public String syntax() {
    return String.format("POP %s", dst.syntax());
  }

  @Override
  public String image() {
    return String.format("000%s111", dst.image());
  }

  @Override
  public void action() {
    base.access().store(Data.zeroExtend(ADDR, SS.access().load()).shiftLeft(Data.valueOf(ADDR, 0x4)));
    dst.access().bitField(0, 7).store(M.access(base.access().load().add(Data.signExtend(ADDR, Data.cast(SWORD, SP.access().load())))).load());
    dst.access().bitField(8, 15).store(M.access(base.access().load().add(Data.signExtend(ADDR, Data.cast(SWORD, SP.access().load().add(Data.valueOf(WORD, 0x1)))))).load());
    SP.access().store(SP.access().load().add(Data.valueOf(WORD, 0x2)));
    instr_size.access().store(instr_size.access().load().add(Data.valueOf(SIZE, 0x1)));
  }
}