/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;

import static ru.ispras.microtesk.model.x86.Shared.*;

public final class PUSHA extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         PUSHA.class,
         "PUSHA",
         new ArgumentDecls(),
         new Shortcuts()
             .addShortcut(new Info_x86(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      return new PUSHA();
    }
  }
  private static final class Info_x86 extends InfoAndRule {
    Info_x86() {
      super(
          x86.class,
          "PUSHA",
          new ArgumentDecls()
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      return new x86(
        new PUSHA()
      );
    }
  }
  public static final IInfo INFO = new Info();

  public PUSHA() {
  }

  @Override
  public String syntax() {
    return "PUSHA";
  }

  @Override
  public String image() {
    return "01100000";
  }

  @Override
  public void action() {
    SP.access().store(SP.access().load().subtract(Data.valueOf(WORD, 0x10)));
    M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0xf))).store(AH.access().load());
    M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0xe))).store(AL.access().load());
    M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0xd))).store(CH.access().load());
    M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0xc))).store(CL.access().load());
    M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0xb))).store(DH.access().load());
    M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0xa))).store(DL.access().load());
    M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0x9))).store(BH.access().load());
    M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0x8))).store(BL.access().load());
    M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0x7))).store(SP.access().bitField(8, 15).load());
    M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0x6))).store(SP.access().bitField(0, 7).load());
    M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0x5))).store(BP.access().bitField(8, 15).load());
    M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0x4))).store(BP.access().bitField(0, 7).load());
    M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0x3))).store(SI.access().bitField(8, 15).load());
    M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0x2))).store(SI.access().bitField(0, 7).load());
    M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0x1))).store(DI.access().bitField(8, 15).load());
    M.access(SS.access().load().add(SP.access().load()).add(Data.valueOf(WORD, 0x0))).store(DI.access().bitField(0, 7).load());
    instr_size.access().store(instr_size.access().load().add(Data.valueOf(SIZE, 0x1)));
  }
}