/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.x86.Shared.*;

public final class inc_proc_word extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         inc_proc_word.class,
         "inc_proc_word",
         new ArgumentDecls()
             .add("op1", WORD));
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final Immediate op1 = (Immediate) getArgument("op1", args);

      return new inc_proc_word(op1);
    }
  }
  public static final IInfo INFO = new Info();

  public final Immediate op1;

  public inc_proc_word(final Immediate op1) {
    assert WORD.equals(op1.getType());
    this.op1 = op1;
  }

  @Override
  public void action() {
    tmpw_res.access().store(Data.zeroExtend(Type.CARD(17), op1.access().load().add(Data.valueOf(WORD, 0x1))));
    OF.access().store(Data.valueOf(BIT, op1.access().bitField(15, 15).load().equals(Data.valueOf(Type.CARD(1), 0x0)) && tmpw_res.access().bitField(15, 15).load().equals(Data.valueOf(Type.CARD(1), 0x1))));
    ZF.access().store(Data.valueOf(BIT, tmpw_res.access().bitField(0, 15).load().equals(Data.valueOf(Type.CARD(16), 0x0))));
    SF.access().store(Data.valueOf(BIT, tmpw_res.access().bitField(15, 15).load().equals(Data.valueOf(Type.CARD(1), 0x1))));
  }
}